function [chain_line,Xint,V0,prof] = labelingbis(ligne,prof,profmin,nbpoint)

%ligne   : the original signal
%nbpoint : number of points for the initial neigbourhood 
%profmin : profondeur minimale d'estimation des singularites


ligne_cour = ligne;
label      = zeros(nbpoint,length(ligne));
vallabel   = zeros(nbpoint,length(ligne));

 for k = 1:nbpoint,
    
    L = length(ligne_cour);
    H = zeros(1,L-2); 
    
    %computation of the first order differences
  
    res = abs(diff(ligne_cour));
   
    H = res(1:end-1)+res(2:end);
    Ind = [];
    for i = 2+3*(nbpoint-k+1):L-2-3*(nbpoint-k+1), 
     if (H(i) > max(H(i+1:i+3*(nbpoint-k+1))) && (H(i-1) > max(H(i-1-3*(nbpoint-k+1):i-2)))) 
      Ind = [Ind i];      
     end 
    end
    
    %There might be several neighbouring intervals of interest   
    %the location of the singularities of interest is written in Indn 
    
    q = 1;
    Indn=[];
  
    while (q <= length(Ind)-1) 
     if Ind(q)+1 == Ind(q+1),
       if (H(Ind(q+1)) >= H(Ind(q)))        
         Indn = [Indn Ind(q+1)];
       else
         Indn = [Indn Ind(q)];
       end
       q = q+2;
     else
      Indn = [Indn Ind(q)];   
      q = q+1;
     end
    end
   
    if ( q == length(Ind))
     Indn = [Indn Ind(q)];
    end
    
    label(k,Indn)    = ones(1,length(Indn));
    vallabel(k,Indn) = H(Indn);
    if (k == profmin)
      V0 = ligne_cour;    
    end
    ligne_cour = (ligne_cour(1:2:end-1)+ligne_cour(2:2:end))/2;
 end   

 %we build the chain lines

 chain_line = cell(1,length(ligne));
 chain_val  = cell(1,length(ligne));

 Xint = (1:length(ligne)).*label(profmin,:);
 Xint = Xint(Xint > 0);
 N    = length(Xint);

 for k = 1:length(Xint),
  chain_line{Xint(k)} = Xint(k); 
  chain_val{Xint(k)}  = vallabel(1,Xint(k));
 end

 k   = profmin;

 %prof determines the maximal depth until which we build up the chains
 
 while (k < prof)&&(isempty(Xint) == 0)
 
  chain_line_cour = chain_line;
  chain_val_cour  = chain_val;
 
  lab = (1:length(ligne)).*label(k+1,:); 
 
  %we rebuild a new chain at each stage taking into account previous detections 
  %we assume that the singularities can be detected 
  
  chain_line = cell(1,length(ligne));  
  chain_val  = cell(1,length(ligne));
 
  Indn = [];

  if (isempty(Xint) == 0)
  
   for q=1:length(Xint), 
    if (mod(Xint(q),2) == 0), 
     if (lab(Xint(q)/2) ~= 0)
      
      Indn = [Indn Xint(q)/2];
      Xcour = chain_line_cour{Xint(q)};
      valcour = chain_val_cour{Xint(q)}; 
      chain_line{Xint(q)/2} = [Xint(q)/2 Xcour];
      chain_val{Xint(q)/2}  = [vallabel(k+1,Xint(q)/2) valcour];      
      
     elseif (lab(Xint(q)/2+1) ~= 0)
      
      Indn = [Indn Xint(q)/2+1];
      Xcour = chain_line_cour{Xint(q)};
      valcour = chain_val_cour{Xint(q)}; 
      chain_line{Xint(q)/2+1} = [Xint(q)/2+1 Xcour]; 
      chain_val{Xint(q)/2+1}  = [vallabel(k+1,Xint(q)/2+1) valcour];

     elseif (lab(Xint(q)/2-1) ~= 0)
      
      Indn = [Indn Xint(q)/2-1];
      Xcour = chain_line_cour{Xint(q)};
      valcour = chain_val_cour{Xint(q)}; 
      chain_line{Xint(q)/2-1} = [Xint(q)/2-1 Xcour];
      chain_val{Xint(q)/2-1}  = [vallabel(k+1,Xint(q)/2-1) valcour];
     end  
    else
     if (lab(floor(Xint(q)/2)) ~= 0)

      Indn = [Indn floor(Xint(q)/2)];
      Xcour = chain_line_cour{Xint(q)};
      valcour = chain_val_cour{Xint(q)}; 
      chain_line{floor(Xint(q)/2)} = [floor(Xint(q)/2) Xcour];
      chain_val{floor(Xint(q)/2)}  = [vallabel(k+1,floor(Xint(q)/2)) valcour];
      
     elseif (lab(floor(Xint(q)/2)-1) ~= 0)
      
      Indn = [Indn floor(Xint(q)/2)-1];
      Xcour = chain_line_cour{Xint(q)};
      valcour = chain_val_cour{Xint(q)}; 
      chain_line{floor(Xint(q)/2)-1} = [floor(Xint(q)/2)-1 Xcour];
      chain_val{floor(Xint(q)/2)-1}  = [vallabel(k+1,floor(Xint(q)/2)-1) valcour];
      
     elseif (lab(floor(Xint(q)/2)+1) ~= 0)
      
      Indn = [Indn floor(Xint(q)/2)+1];
      Xcour = chain_line_cour{Xint(q)};
      valcour = chain_val_cour{Xint(q)}; 
      chain_line{floor(Xint(q)/2)+1} = [floor(Xint(q)/2)+1 Xcour];
      chain_val{floor(Xint(q)/2)+1}  =  [vallabel(k+1,floor(Xint(q)/2)+1) valcour];

     end     
    end
   end
   Xint = Indn;
  end
  k = k+1;
 end
end 


