function V = predictionNL(ligne,label) 
%on fait la décomposition de ligne en utilisant label

 ligne = double(ligne); 
 L = length(ligne);  
 V = zeros(1,2*L); 

 %calcul des valeurs aux bords (à gauche)
 V(1)=5/4*ligne(1)-1/4*ligne(2);
 V(2)=3/4*ligne(1)+1/4*ligne(2); 

 %affectation d'un label pour tous les intervalles
 lab = zeros(1,L); % pour le cas centré
 %on utilise le label pour caractériser chaque intervalle
 for i = 1:length(label)
  lab(label(i))   = 2;
  lab(label(i)-1) = -1;
  lab(label(i)+1) = 1;
 end
 
 %calcul du beta pour la prédiction SR
 for i = 5:L-3
  a = (ligne(i)-ligne(i+1))/(ligne(i-1)-ligne(i+1));
  
  if (lab(i) == 2)
   if (a > 0)&&(a < 1/2)
     b(i) = 1/8-(1/2-a)/4;
   elseif (a >= 1/2)&&(a < 1)
      b(i) = 1/8+(a-1/2)/4;
   elseif (a >= 1)
      b(i) = 1/4;
   elseif (a <= 0)
      b(i) = 0;  
   end
  end
 end

 for i = 2:L-1 
  if lab(i) == 0,
   %prédiction centrée
    V(2*i-1) = ligne(i)+1/8*(ligne(i-1)-ligne(i+1)); 
	V(2*i)   = ligne(i)-1/8*(ligne(i-1)-ligne(i+1)); 
  elseif lab(i) == -1, 
   %prédiction décentrée gauche
    V(2*i-1) = 3/4*ligne(i)+1/4*ligne(i-1); 
 	V(2*i)   = 5/4*ligne(i)-1/4*ligne(i-1);
  elseif lab(i) == 1,
    V(2*i-1) = 5/4*ligne(i)-1/4*ligne(i+1);
    V(2*i)   = 3/4*ligne(i)+1/4*ligne(i+1); 
  else
    V(2*i-1) = ligne(i)+b(i)*(ligne(i-1)-ligne(i))+(b(i)-1/4)*(ligne(i+1)-ligne(i));
    V(2*i)   = ligne(i)-b(i)*(ligne(i-1)-ligne(i))-(b(i)-1/4)*(ligne(i+1)-ligne(i));
  end 
 end   

 %calcul des valeurs aux bords (à droite)
 V(2*L-1) = 3/4*ligne(L)+1/4*ligne(L-1);
 V(2*L)   = 5/4*ligne(L)-1/4*ligne(L-1); 

